//------------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//------------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//------------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Load dynamic link library---ps2pdf.dll
BOOL TForm1::LoadDLL()
{
	nHandle=LoadLibrary("ps2pdf.dll");
	if( nHandle == NULL ) goto Error_Flag;

	apCreate=(pAPCreate)GetProcAddress(nHandle,"_apCreate@0");
	if( apCreate == NULL ) goto Error_Flag;

	apClose=(pAPClose)GetProcAddress(nHandle,"_apClose@4");
	if( apClose == NULL ) goto Error_Flag;

	apConvert = (pAPConvert)GetProcAddress(nHandle,"_apConvert@4");
	if( apConvert == NULL ) goto Error_Flag;

	apSetFunc=(pAPSetFunc)GetProcAddress(nHandle,"_apSetFunc@24");
	if( apSetFunc == NULL ) goto Error_Flag;

	apGetFunc=(pAPGetFunc)GetProcAddress(nHandle,"_apGetFunc@24");
	if( apGetFunc == NULL ) goto Error_Flag;

	return TRUE;

Error_Flag:
	FreeDLL(); 
	return FALSE;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Free dynamic link library---ps2pdf.dll
void TForm1::FreeDLL()
{
	if( nHandle == NULL )
		return;

	FreeLibrary(nHandle);
	nHandle = NULL;	
}
//------------------------------------------------------------------------------


// Convert ps files to a general pdf file.
void __fastcall TForm1::btnDemo1Click(TObject *Sender)
{
	long id, iRet;

	//Load dynamic link library---ps2pdf.dll
	if( !LoadDLL() ){
		ShowMessage("Loading dynamic link library---ps2pdf.dll error!");
		return;
	}

    id = apCreate();
	apSetFunc(id, AP_Set_Input, 0, 0, "test1.ps", NULL);
    apSetFunc(id, AP_Set_Input, 0, 0, "test2.ps", NULL);
	apSetFunc(id, AP_Set_Output, 0, 0, "test1.pdf", NULL);

    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, "untitled document");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, "adultpdf");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, "PS to PDF sdk demo");

	iRet = apConvert(id);
	apClose(id);

	//Free dynamic link library---ps2pdf.dll
	FreeDLL();
}


// Convert ps files to an restricted pdf file.
void __fastcall TForm1::btnDemo2Click(TObject *Sender)
{
	long id, iRet;
    char sOwnerPw[] = "1111";
	char sUserPw[]  = "2222";

	//Load dynamic link library---ps2pdf.dll
	if( !LoadDLL() ){
		ShowMessage("Loading dynamic link library---ps2image.dll error!");
		return;
	}

	// Convert one ps file to grayscale jpeg file.
	id = apCreate();
	apSetFunc(id, AP_Set_Input, 0, 0, "test1.ps", NULL);
    apSetFunc(id, AP_Set_Input, 0, 0, "test2.ps", NULL);
	apSetFunc(id, AP_Set_Output, 0, 0, "test2.pdf", NULL);

    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, "untitled document");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, "adultpdf");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, "PS to PDF sdk demo");

    apSetFunc(id, AP_Set_PDFEncrypt, AP_PDF_ENCRYPT_128, AP_PDF_PERMISSION_PRINT+AP_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw);
    
	iRet = apConvert(id);
	apClose(id);

	//Free dynamic link library---ps2pdf.dll
	FreeDLL();
}


