using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //requirement class

namespace demo_cs_2005
{
    public partial class Form1 : Form
    {
        //SDK interface definitions
        //==============================================================================================================
        [DllImport("ps2pdf", EntryPoint = "_apCreate@0", CallingConvention = CallingConvention.StdCall)]
        public static extern int apCreate();

        [DllImport("ps2pdf", EntryPoint = "_apClose@4", CallingConvention = CallingConvention.StdCall)]
        public static extern void apClose(int id);

        [DllImport("ps2pdf", EntryPoint = "_apConvert@4", CallingConvention = CallingConvention.StdCall)]
        public static extern int apConvert(int id);

        [DllImport("ps2pdf", EntryPoint = "_apSetFunc@24", CallingConvention = CallingConvention.StdCall)]
        public static extern int apSetFunc(int id, int code, int nOptVal1,int nOptVal2,string sOptVal1,string sOptVal2);

        [DllImport("ps2pdf", EntryPoint = "_apGetFunc@24", CallingConvention = CallingConvention.StdCall)]
        public static extern int apGetFunc(int id, int code, int nOptVal1,int nOptVal2,string sOptVal1,string sOptVal2);
        //==============================================================================================================

        //Supported option definitions
        const int AP_Set_Output = 3000;
        const int AP_Set_Input = 3001;
        const int AP_Set_PDFInfo = 3006;
        const int AP_Set_PDFEncrypt = 3007;
        
        //Supported pdf header information
        const string AP_PDF_TITLE = "title";
        const string AP_PDF_SUBJECT = "subject";
        const string AP_PDF_AUTHOR = "author";
        const string AP_PDF_KEYWORDS = "keywords";
        const string AP_PDF_APPLICATION = "creator";
        
        //Supported encryption mode
        const int AP_PDF_ENCRYPT_40 = 40;
        const int AP_PDF_ENCRYPT_128 = 128;

        //Supported user access permissions
        const int AP_PDF_PERMISSION_NONE = 0;
        const int AP_PDF_PERMISSION_PRINT = 1;
        const int AP_PDF_PERMISSION_COPYING = 2;
        const int AP_PDF_PERMISSION_MODIFY = 4;
        const int AP_PDF_PERMISSION_ALL = 7;

        public Form1()
        {
            InitializeComponent();
        }

        // Convert ps files to a general pdf file.
        private void btnDemo1_Click(object sender, EventArgs e)
        {
            int id, iRet;

            id = apCreate();
            apSetFunc(id, AP_Set_Input, 0, 0, "test1.ps", "");
            apSetFunc(id, AP_Set_Input, 0, 0, "test2.ps", "");
            apSetFunc(id, AP_Set_Output, 0, 0, "test1.pdf", "");

            apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, "untitled document");
            apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, "adultpdf");
            apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, "PS to PDF sdk demo");

            iRet = apConvert(id);
            apClose(id);
        }

        // Convert ps files to an restricted pdf file.
        private void btnDemo2_Click(object sender, EventArgs e)
        {
            int id, iRet;
            string sUserPw = "1111";
            string sOwnerPw = "2222";

            id = apCreate();
            apSetFunc(id, AP_Set_Input, 0, 0, "test1.ps", "");
            apSetFunc(id, AP_Set_Input, 0, 0, "test2.ps", "");
            apSetFunc(id, AP_Set_Output, 0, 0, "test2.pdf", "");

            apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, "untitled document");
            apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, "adultpdf");
            apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, "PS to PDF sdk demo");

            apSetFunc(id, AP_Set_PDFEncrypt, AP_PDF_ENCRYPT_128, AP_PDF_PERMISSION_PRINT + AP_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw);

            iRet = apConvert(id);
            apClose(id);
        }
    }
}