unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, apconst;

type
  TForm1 = class(TForm)
    btnDemo1: TButton;
    btnDemo2: TButton;
    procedure btnDemo1Click(Sender: TObject);
    procedure btnDemo2Click(Sender: TObject);
  private
    { Private declarations }
    //SDK interface definitions.
    //For more,please refer to "apconst.pas"
    hDLL: HMODULE;
    apCreate: FapCreate;
    apClose: FapClose;
    apConvert: FapConvert;
    apSetFunc: FapSetFunc;
    apGetFunc: FapGetFunc;

    function LoadDLL(): BOOL;
    function FreeDLL(): BOOL;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Load dynamic link library---ps2pdf.dll
function TForm1.LoadDLL(): BOOL;
var
   pFunc: FARPROC;
label
   ERROR_FLAG;
begin
   hDLL := LoadLibrary('ps2pdf.dll');
   if hDLL = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(hDLL, '_apCreate@0');
	 if pFunc = nil then goto ERROR_FLAG;
   apCreate := pFunc;

	 pFunc := GetProcAddress(hDLL, '_apClose@4');
	 if pFunc = nil then goto ERROR_FLAG;
   apClose := pFunc;

	 pFunc := GetProcAddress(hDLL, '_apConvert@4');
	 if pFunc = nil then goto ERROR_FLAG;
   apConvert := pFunc;

	 pFunc := GetProcAddress(hDLL, '_apSetFunc@24');
	 if pFunc = nil then goto ERROR_FLAG;
   apSetFunc := pFunc;

	 pFunc := GetProcAddress(hDLL, '_apGetFunc@24');
	 if pFunc = nil then goto ERROR_FLAG;
   apGetFunc := pFunc;

   Result := TRUE;
   exit;

ERROR_FLAG:
   Result := FALSE;
end;

// Free dynamic link library---ps2pdf.dll
function TForm1.FreeDLL(): BOOL;
begin
   if hDLL <> 0  then
   begin
      FreeLibrary(hDLL);
      hDLL := 0;
   end;
   Result := TRUE;
end;

// Convert ps files to a general pdf file.
procedure TForm1.btnDemo1Click(Sender: TObject);
var
	 id, iRet: Longint;
begin
   if LoadDLL() = FALSE then exit;

   id := apCreate();
   apSetFunc(id, AP_Set_Input, 0, 0, 'test1.ps', 0);  //input file
   apSetFunc(id, AP_Set_Input, 0, 0, 'test2.ps', 0);  //input file
   apSetFunc(id, AP_Set_Output, 0, 0, 'test1.pdf', 0);

   apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, 'untitled document');
   apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, 'adultpdf');
   apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, 'PS to PDF sdk demo');

   iRet := apConvert(id);
   apClose(id);
   
   FreeDLL();
end;

// Convert ps files to an restricted pdf file.
procedure TForm1.btnDemo2Click(Sender: TObject);
var
	 id, iRet: Longint;
   sUserPw, sOwnerPw: String;
begin
   if LoadDLL() = FALSE then exit;
   sUserPw := '1111';
   sOwnerPw := '2222';
   
   id := apCreate();
   apSetFunc(id, AP_Set_Input, 0, 0, 'test1.ps', 0);
   apSetFunc(id, AP_Set_Input, 0, 0, 'test2.ps', 0);
   apSetFunc(id, AP_Set_Output, 0, 0, 'test2.pdf', 0);

   apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, 'untitled document');
   apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, 'adultpdf');
   apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, 'PS to PDF sdk demo');

   apSetFunc(id, AP_Set_PDFEncrypt, AP_PDF_ENCRYPT_128, AP_PDF_PERMISSION_PRINT+AP_PDF_PERMISSION_COPYING, PChar(sUserPw), PChar(sOwnerPw));
    
   iRet := apConvert(id);
   apClose(id);

   FreeDLL();
end;

end.


