#include <Windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "apconst.h"

HMODULE    nHandle=NULL;
pAPCreate  apCreate;
pAPClose   apClose;
pAPConvert apConvert;
pAPSetFunc apSetFunc;
pAPGetFunc apGetFunc;

BOOL LoadDLL();
void FreeDLL();


//Load dynamic link library---ps2pdf.dll
BOOL LoadDLL()
{
	nHandle=LoadLibrary("ps2pdf.dll");
	if( nHandle == NULL ) goto Error_Flag;

	apCreate=(pAPCreate)GetProcAddress(nHandle,"_apCreate@0");
	if( apCreate == NULL ) goto Error_Flag;

	apClose=(pAPClose)GetProcAddress(nHandle,"_apClose@4");
	if( apClose == NULL ) goto Error_Flag;

	apConvert = (pAPConvert)GetProcAddress(nHandle,"_apConvert@4");
	if( apConvert == NULL ) goto Error_Flag;

	apSetFunc=(pAPSetFunc)GetProcAddress(nHandle,"_apSetFunc@24");
	if( apSetFunc == NULL ) goto Error_Flag;

	apGetFunc=(pAPGetFunc)GetProcAddress(nHandle,"_apGetFunc@24");
	if( apGetFunc == NULL ) goto Error_Flag;

	return TRUE;

Error_Flag:
	FreeDLL(); 
	return FALSE;
}

//Free dynamic link library---ps2pdf.dll
void FreeDLL()
{
	if( nHandle == NULL )
		return;

	FreeLibrary(nHandle);
	nHandle = NULL;	
}

//function: This demo converts ps file(s) to pdf files.
int main()
{
	long id, iRet;
    char sOwnerPw[] = "1111";
	char sUserPw[]  = "2222";

	//Load dynamic link library---ps2pdf.dll
	if( !LoadDLL() ) exit(FALSE);


	// Convert ps files to a general pdf file.
    id = apCreate();
	apSetFunc(id, AP_Set_Input, 0, 0, "test1.ps", NULL);
    apSetFunc(id, AP_Set_Input, 0, 0, "test2.ps", NULL);
	apSetFunc(id, AP_Set_Output, 0, 0, "test1.pdf", NULL);

    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, "untitled document");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, "adultpdf");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, "PS to PDF sdk demo");

	iRet = apConvert(id);
	apClose(id);


	// Convert ps files to an restricted pdf file.
	id = apCreate();
	apSetFunc(id, AP_Set_Input, 0, 0, "test1.ps", NULL);
    apSetFunc(id, AP_Set_Input, 0, 0, "test2.ps", NULL);
	apSetFunc(id, AP_Set_Output, 0, 0, "test2.pdf", NULL);

    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_TITLE, "untitled document");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_AUTHOR, "adultpdf");
    apSetFunc(id, AP_Set_PDFInfo, 0, 0, AP_PDF_APPLICATION, "PS to PDF sdk demo");

    apSetFunc(id, AP_Set_PDFEncrypt, AP_PDF_ENCRYPT_128, AP_PDF_PERMISSION_PRINT+AP_PDF_PERMISSION_COPYING, sUserPw, sOwnerPw);
    
	iRet = apConvert(id);
	apClose(id);


	//Free dynamic link library---ps2pdf.dll
	FreeDLL();
	exit(TRUE);
}
